package com.uca.dao;

import com.uca.core.*;
import com.uca.dao.*;
import com.uca.entity.*;
import java.sql.*;

public class _Initializer {

    public static ProfEntity DEBUG_BORIS_ADMIN;

    public static void DropTable(String name)
    {
        try {
            _Connector.getInstance().prepareStatement("DROP TABLE "+name+";").executeUpdate();
        } catch (Exception e){
            System.out.println(e.toString());
            throw new RuntimeException("could not drop table: "+name);
        }
    }

    public static void CreateTable(String command)
    {
        //System.out.println("Creation de la table "+command.split(" ")[0]);
        System.out.println(command);

        command = "CREATE TABLE IF NOT EXISTS "+command;
        try {
            PreparedStatement statement;

            //Init articles table
            _Connector.getInstance().prepareStatement(command).executeUpdate();
        } catch (Exception e){
            System.out.println(e.toString());
            throw new RuntimeException("could not create database: "+command);
        }
    }

    public static void Init(){
        DropTable("users");
        DropTable("profs");
        DropTable("eleves");
        DropTable("gommettes");
        DropTable("gommetteAttribs");

        CreateTable("users (id int primary key auto_increment, firstname varchar(100), lastname varchar(100));");
        CreateTable("profs (id int primary key auto_increment, firstname varchar(100), lastname varchar(100), username  varchar(100), password varchar(100));");
        CreateTable("eleves (id int primary key auto_increment, firstname varchar(100), lastname varchar(100), nomClasse varchar(100), dateNaissance DATE);");
        CreateTable("gommettes (id int primary key auto_increment, nom varchar(100), description varchar(100), couleur varchar(100));");
        CreateTable("gommetteAttribs (id int primary key auto_increment, idEleve int, idProf int, idGommette int, dateAttribution DATE, raison varchar(500));");

        UserEntity e = Core.User.create("Le père de toto", "pas toto");
        Core.User.create("Jean",  "Némar");
        Core.User.create("Paul",  "Hisse");
        Core.User.create("Kelly", "Diote");
        Core.User.create("Alain", "Térieur");
        Core.User.create("Matt",  "Lecul");
        Core.User.create("Lorie", "Fice");
        Core.User.create("Sacha", "Touille");
        Core.User.create("Terry", "Golo");
        Core.User.create("Judas", "Nanas");

        DEBUG_BORIS_ADMIN = Core.Prof.create("Boris", "OUYA", "DaWarudo","KonoDioDa");
        ProfEntity toto  = Core.Prof.create("Thomas", "TAMAGNAUD", "CéMoiLul","BlockusMaster");

        GommetteEntity sagePetit = Core.Gommette.create("Brave Petit", Couleur.Vert, "S'est montré obéissant devant le prêtre");
        GommetteEntity uniCorn = Core.Gommette.create("Badge Unicorne", Couleur.ArcEnCiel, "C'est magique!");


        EleveEntity bibi = Core.Eleve.create("Bibi","Johnson",new java.sql.Date(44938),"Zarbi");
        EleveEntity bobo = Core.Eleve.create("Bobo","Bis",new java.sql.Date(10),"Pokemon");

        Core.GommetteAttrib.create(bibi.getId(), DEBUG_BORIS_ADMIN.getId(), sagePetit.getId(), new java.sql.Date(44938), "Aucune raison");
        Core.GommetteAttrib.create(bibi.getId(), toto.getId(), uniCorn.getId(), new java.sql.Date(44938), "Our Little Poney");

        Core.GommetteAttrib.create(bobo.getId(), DEBUG_BORIS_ADMIN.getId(), uniCorn.getId(), new java.sql.Date(32), "Bravo bobo");

        
    }
}
